
%{
#undef SWIG_I

#include <apt-pkg/pkgcache.h>
#include <apt-pkg/depcache.h>

#include <wibble/amorph.h>

#include <ept/forward.h>
#include <ept/init.h>
#include <ept/error.h>
#include <ept/sources.h>
#include <ept/configuration/apt.h>

#include <ept/cache/cache.h>
#include <ept/cache/package.h>
#include <ept/cache/version.h>
#include <ept/cache/tag.h>

#include <ept/predicate/combinators.h>
#include <ept/predicate/predicate.h>
#include <ept/predicate/factory.h>

#include <ept/cache/apt/packages.tcc>
#include <ept/cache/tag.tcc>
#include <ept/cache/debtags/vocabulary.tcc>
#include <ept/cache/debtags/vocabulary.h>
#include <ept/cache/debtags/tagmap.h>
#include <ept/cache/debtags/tagmap.tcc>
#include <ept/cache/relation.tcc>

using namespace wibble;
using namespace ept;
using namespace t;
%}

#define SWIG_I

// TODO: autogenerate the following ... stuff? (gccxml output could possibly help)
// fix conversion for this, swig breaks
%typemap(in) ept::t::cache::debtags::TagMap< ept::configuration::Apt >::Tag const & {
  void *p_$1;
  SWIG_ConvertPtr($input, &p_$1, SWIGTYPE_p_ept__t__cache__TagTept__configuration__Apt_t,  0 );
  $1 = reinterpret_cast< ept::t::cache::debtags::TagMap< ept::configuration::Apt >::Tag * >( p_$1 );
}

// again, swig doesn't get the type right
%typemap(out) tagcoll::coll::coll_traits< ept::t::cache::debtags::TagMap< ept::configuration::Apt > >::itemset_type {
  $result = SWIG_NewPointerObj( (new tagcoll::coll::coll_traits< ept::t::cache::debtags::TagMap< ept::configuration::Apt > >::itemset_type( result ) ), SWIGTYPE_p_std__setTept__t__cache__PackageTept__configuration__Apt_t_t, SWIG_POINTER_OWN );
  // SWIGTYPE_p_std__setTept__t__cache__TagTept__configuration__Apt_t_t
}

// %apply std::set< ept::configuration::apt::Tag > { tagcoll::coll::coll_traits< ept::t::cache::debtags::TagMap< ept::configuration::Apt > >::itemset_type };

%include <apt-pkg/pkgcache.h>
%include <apt-pkg/error.h>

namespace ept { void init(); } // init.h breaks swig

%include <file.i>
%include <std_string.i>

namespace std {
template< typename T > struct set {};
}

%include <wibble/mixin.h>
%include <wibble/amorph.h>
%include <wibble/range.h>

// for coll_traits, but it doesn't actually help
%include <tagcoll/coll/base.h>

%include <ept/cache/entity.h>
%include <ept/cache/cache.h>
%include <ept/cache/package.h>
%include <ept/cache/tag.h>
%include <ept/cache/version.h>
%include <ept/cache/relation.h>
%include <ept/cache/apt/index.h>
%include <ept/cache/apt/packages.h>
%include <ept/cache/apt/records.h>
%include <ept/cache/debtags/vocabulary.h>
%include <ept/cache/debtags/tagmap.h>
%include <ept/predicate/combinators.h>
%include <ept/predicate/predicate.h>
%include <ept/forward.h>

// returns nested struct, not useful anyway
%ignore ept::t::cache::debtags::Vocabulary< ept::configuration::Apt >::facetIndex() const;
%ignore ept::t::cache::debtags::Vocabulary< ept::configuration::Apt >::tagIndex() const;

// returns nested struct
%ignore ept::t::cache::debtags::TagMap< ept::configuration::Apt >::begin() const;
%ignore ept::t::cache::debtags::TagMap< ept::configuration::Apt >::end() const;

// XXX does not compile
%ignore ept::t::cache::debtags::TagMap< ept::configuration::Apt >::changes() const;

%include "swigified.i"

#ifdef SWIGPYTHON
%include "python.i"
#endif

#ifdef SWIGRUBY
%include "ruby.i"
#endif

iter( ept::t::cache::apt::Aggregator<ept::configuration::Apt> )
range( ept::t::cache::Package< ept::configuration::Apt > )
range( ept::t::cache::Relation< ept::configuration::Apt > )
range( ept::t::cache::Version< ept::configuration::Apt > )

%template( setoftag ) std::set< ept::t::cache::Tag< ept::configuration::Apt > >;
%template( setofpackage ) std::set< ept::t::cache::Package< ept::configuration::Apt > >;
wrap_set( ept::t::cache::Package< ept::configuration::Apt > );
